#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include "st_uvc.h"
#include "myuvc.h"

//#define UVC_TEST_DUMMY
#define UVC_SUPPORT_MMAP

#ifdef UVC_TEST_DUMMY
static int test_func(){return 0;}
#define UVC_DEMO_Init            test_func
#define UVC_DEMO_Deinit          test_func
#define UVC_DEMO_MM_FillBuffer   test_func
#define UVC_DEMO_UP_FillBuffer   test_func
#define UVC_DEMO_StartCapture    test_func
#define UVC_DEMO_StopCapture     test_func
#endif

#ifdef UVC_SUPPORT_MMAP
#define UVC_MEMORY_MODE UVC_MEMORY_MMAP
#else
#define UVC_MEMORY_MODE UVC_MEMORY_USERPTR
#endif

static bool g_exit = false;

void Stop_Help(int signo){
    g_exit = true;
}

int32_t main_sub(u_int8_t nbuf, uint8_t mult, u_int8_t burst)
{
    ST_UVC_Setting_t pstSet={nbuf, mult, burst, UVC_MEMORY_MODE,USB_ISOC_MODE};
    ST_UVC_OPS_t fops = {
                            UVC_DEMO_Init,
                            UVC_DEMO_Deinit,
#ifdef UVC_SUPPORT_MMAP
                            .m={UVC_DEMO_MM_FillBuffer},
#else
                            .u={UVC_DEMO_UP_FillBuffer},
#endif
                            UVC_DEMO_StartCapture,
                            UVC_DEMO_StopCapture
                         };

    ST_UVC_ChnAttr_t pstAttr ={pstSet,fops};
    ExecFunc(ST_UVC_Init("/dev/video0"),0);
    ExecFunc(ST_UVC_CreateDev(&pstAttr),0);
    ExecFunc(ST_UVC_StartDev(),0);

    while(!g_exit)
        usleep(1*1000*1000);

    ExecFunc(ST_UVC_StopDev(),0);
    ExecFunc(ST_UVC_DestroyDev(),0);
    ExecFunc(ST_UVC_Uninit(),0);
    return 0;
}

int32_t main(int argc, char *argv[])
{
    if(!fork())
    {
        u_int8_t nbuf = 4, mult = 2, burst = 0;
        int result;

        while((result = getopt(argc, argv, "n:m:b:")) != -1)
        {
            switch(result)
            {
                case 'n':
                   nbuf = atoi(optarg);
                   break;
                case 'm':
                   mult = atoi(optarg);
                   break;
                case 'b':
                   burst = atoi(optarg);
                   break;
                default:
                   break;
            }
        }
        printf("nbuf:%u mult:%u burst:%u\n", nbuf, mult, burst);
        main_sub(nbuf, mult, burst);
    }

    signal(SIGINT, Stop_Help);

    while(!g_exit)
        usleep(1*1000*1000);

    return 0;
}
